<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZ: scripts/4_World/Classes/CraftingManager.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZ<span id="projectnumber">&#160;1.19.155390</span>
   </div>
   <div id="projectbrief">DayZ Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('d5/d38/_crafting_manager_8c_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">CraftingManager.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d5/d38/_crafting_manager_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span> </div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html">    2</a></span><span class="keyword">class </span><a class="code hl_class" href="../../d4/db5/class_crafting_manager.html">CraftingManager</a></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span>{</div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#a88610f641a67c5d0324f194c5a8510a4">    4</a></span>    <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a88610f641a67c5d0324f194c5a8510a4">CM_MODE_NONE</a> = 0;</div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#a49e45ddb0c3044c28f0571577422ff9a">    5</a></span>    <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a49e45ddb0c3044c28f0571577422ff9a">CM_MODE_WORLD</a> = 1;</div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#ab8193febe884400782cfa280e90d76d3">    6</a></span>    <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ab8193febe884400782cfa280e90d76d3">CM_MODE_INVENTORY</a> = 2;</div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span> </div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#ac0b173f5f92412d43d2db3a9ddb8f431">    8</a></span>    <a class="code hl_class" href="../../d5/da8/class_player_base.html">PlayerBase</a> <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac0b173f5f92412d43d2db3a9ddb8f431">m_player</a>;</div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#adbd5f83d3c27e17223ebf1800a98698d">    9</a></span>    PluginRecipesManager <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#adbd5f83d3c27e17223ebf1800a98698d">m_recipesManager</a>; </div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#afe03b4ca722762ad9c475d6c04d968d5">   10</a></span>    <a class="code hl_class" href="../../dd/dfb/class_action_variant_manager.html">ActionVariantManager</a> <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#afe03b4ca722762ad9c475d6c04d968d5">m_actionVariantManager</a>;</div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#a2e33a35b16fddc62a3c41f93c4d580e1">   11</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a2e33a35b16fddc62a3c41f93c4d580e1">m_recipeID</a>;</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#a73cb57468e476308578833901ef8fbcf">   12</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a73cb57468e476308578833901ef8fbcf">m_contextualRecipeID</a>;</div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#ac3c9a0c305d2d9485d14bbc9aaa730b8">   13</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac3c9a0c305d2d9485d14bbc9aaa730b8">m_recipeCount</a>;</div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#a77951b2f295e03439335f622e554d26c">   14</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a77951b2f295e03439335f622e554d26c">m_craftingMode</a>;</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#ad6ebd6b1f6ef0a91b33aeb8989065480">   15</a></span>    <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ad6ebd6b1f6ef0a91b33aeb8989065480">m_item1</a>;</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#a2fbd85d524f1eb183d21c2c129041f86">   16</a></span>    <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a2fbd85d524f1eb183d21c2c129041f86">m_item2</a>;</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span>    </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#a170fde65a6c0be64a4e3388d1ba1f271">   18</a></span>    ref <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;int&gt;</a> <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a170fde65a6c0be64a4e3388d1ba1f271">m_recipes</a>;</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span> </div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#a2b252f87edfa03639003562f38f0a30f">   20</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/db5/class_crafting_manager.html#a2b252f87edfa03639003562f38f0a30f">CraftingManager</a>(<a class="code hl_class" href="../../d5/da8/class_player_base.html">PlayerBase</a> player, PluginRecipesManager recipesManager)</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span>    {</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>        <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#adbd5f83d3c27e17223ebf1800a98698d">m_recipesManager</a> = recipesManager;</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>        <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac0b173f5f92412d43d2db3a9ddb8f431">m_player</a> = player;</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>        <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a77951b2f295e03439335f622e554d26c">m_craftingMode</a> = <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a88610f641a67c5d0324f194c5a8510a4">CM_MODE_NONE</a>;</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span>        <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#afe03b4ca722762ad9c475d6c04d968d5">m_actionVariantManager</a> = <a class="code hl_class" href="../../d7/da1/class_action_manager_client.html">ActionManagerClient</a>.<a class="code hl_function" href="../../d7/da1/class_action_manager_client.html#ae1daf331f86facb73f8b9efbacc9031c">GetVariantManager</a>( <a class="code hl_class" href="../../d6/def/class_action_world_craft.html">ActionWorldCraft</a> );</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span>        <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#afe03b4ca722762ad9c475d6c04d968d5">m_actionVariantManager</a>.<a class="code hl_function" href="../../dd/dfb/class_action_variant_manager.html#a18286657e9f50784b4839e7f886cba09">GetOnUpdateInvoker</a>().<a class="code hl_function" href="../../d4/d2d/class_script_invoker.html#a57356e0ea629b280f24b5fcbe488a528">Clear</a>();</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>        <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#afe03b4ca722762ad9c475d6c04d968d5">m_actionVariantManager</a>.<a class="code hl_function" href="../../dd/dfb/class_action_variant_manager.html#a18286657e9f50784b4839e7f886cba09">GetOnUpdateInvoker</a>().<a class="code hl_function" href="../../d4/d2d/class_script_invoker.html#abeb2392b2e3dc0a34d0c5cafc96a288e">Insert</a>(<a class="code hl_function" href="../../d9/dc3/group___tools.html#gab414e48870421e21bf5553f4033493b0">OnUpdate</a>);</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span>        <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a170fde65a6c0be64a4e3388d1ba1f271">m_recipes</a> = <span class="keyword">new</span> <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;int&gt;</a>;</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>    }</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span> </div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#afa1ece4b767b0b206cf0b52dca1049e6">   31</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/db5/class_crafting_manager.html#afa1ece4b767b0b206cf0b52dca1049e6">SetRecipeID</a>(<span class="keywordtype">int</span> recipeID)</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span>    {</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>        <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a2e33a35b16fddc62a3c41f93c4d580e1">m_recipeID</a> = recipeID;</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>    }</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    </div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#a911ea59400a6afa0eb7abcfe7d04d8d0">   36</a></span>    <span class="keywordtype">int</span> <a class="code hl_function" href="../../d4/db5/class_crafting_manager.html#a911ea59400a6afa0eb7abcfe7d04d8d0">GetRecipeID</a>()</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>    {</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a2e33a35b16fddc62a3c41f93c4d580e1">m_recipeID</a>;</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>    }</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>    </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#a3bbc9b43adb537feb84300a3ce6dc4aa">   41</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d4/db5/class_crafting_manager.html#a3bbc9b43adb537feb84300a3ce6dc4aa">IsInventoryCraft</a>()</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>    {</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a77951b2f295e03439335f622e554d26c">m_craftingMode</a> == <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ab8193febe884400782cfa280e90d76d3">CM_MODE_INVENTORY</a>;</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>    }</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>    </div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#a6a4c63fac63c466fbc5c3f7a861b4611">   46</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d4/db5/class_crafting_manager.html#a6a4c63fac63c466fbc5c3f7a861b4611">IsWorldCraft</a>()</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>    {</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a77951b2f295e03439335f622e554d26c">m_craftingMode</a> == <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a49e45ddb0c3044c28f0571577422ff9a">CM_MODE_WORLD</a>;</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>    }</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>    </div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#a34f6e34fa2e440b3378332d9dd69e003">   51</a></span>    <span class="keywordtype">int</span> <a class="code hl_function" href="../../d4/db5/class_crafting_manager.html#a34f6e34fa2e440b3378332d9dd69e003">GetRecipesCount</a>()</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>    {</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>        <span class="keywordflow">return</span>  <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac3c9a0c305d2d9485d14bbc9aaa730b8">m_recipeCount</a>;</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>    }</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>     <span class="comment">// deprecated</span></div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#a6da973233f240fdaac28e2cad6f97631">   56</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/db5/class_crafting_manager.html#a6da973233f240fdaac28e2cad6f97631">SetNextRecipe</a>()</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>    {</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span> </div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>    }</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>    </div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#a5cd5f0e4798594b92213aa9d53ea2a45">   61</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/db5/class_crafting_manager.html#a5cd5f0e4798594b92213aa9d53ea2a45">OnUpdate</a>( <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a> item, <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a> target, <span class="keywordtype">int</span> component_index )</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>    {</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>        <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> item1 = <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a>.Cast( item );</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>        <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> item2 = <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a>.Cast( target );</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>        </div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>        <span class="keywordflow">if</span> ( <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac0b173f5f92412d43d2db3a9ddb8f431">m_player</a>.GetActionManager().GetRunningAction() )</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>        </div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>        <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> item_in_hands = <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac0b173f5f92412d43d2db3a9ddb8f431">m_player</a>.GetItemInHands();</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>        </div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>        <span class="keywordflow">if</span> (!item1 || !item2)</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>        {</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>            <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac3c9a0c305d2d9485d14bbc9aaa730b8">m_recipeCount</a> = 0;</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>            <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a77951b2f295e03439335f622e554d26c">m_craftingMode</a> = <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a88610f641a67c5d0324f194c5a8510a4">CM_MODE_NONE</a>;</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>            <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#afe03b4ca722762ad9c475d6c04d968d5">m_actionVariantManager</a>.<a class="code hl_function" href="../../dd/dfb/class_action_variant_manager.html#a97283f11538fbcc2b3b53b2fd705a969">Clear</a>();</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>        }</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>        {</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>            </div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>            <span class="keywordflow">if</span> ( item1 != item_in_hands &amp;&amp; item2 != item_in_hands )</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>            {</div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>                <a class="code hl_class" href="../../d6/dc5/class_inventory_location.html">InventoryLocation</a> il1 = <span class="keyword">new</span> <a class="code hl_class" href="../../d6/dc5/class_inventory_location.html">InventoryLocation</a>;</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>                <a class="code hl_class" href="../../d6/dc5/class_inventory_location.html">InventoryLocation</a> il2 = <span class="keyword">new</span> <a class="code hl_class" href="../../d6/dc5/class_inventory_location.html">InventoryLocation</a>;</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>                </div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>                item1.GetInventory().GetCurrentInventoryLocation(il1);</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>                item2.GetInventory().GetCurrentInventoryLocation(il2);</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>                </div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>                <a class="code hl_function" href="../../d0/d62/group___debug.html#ga786b160dafbe15abb829786ba345cb15">Error</a>(<span class="stringliteral">&quot;Crafting manager - both of items are out of hands - item1: &quot;</span> + il1.<a class="code hl_function" href="../../d6/dc5/class_inventory_location.html#ae6e0792c2508f75cb3c15d5f7e7a2b8e">DumpToString</a>() + <span class="stringliteral">&quot; item2: &quot;</span> + il2.<a class="code hl_function" href="../../d6/dc5/class_inventory_location.html#ae6e0792c2508f75cb3c15d5f7e7a2b8e">DumpToString</a>() + <span class="stringliteral">&quot; / item in hands: - &quot;</span> + item_in_hands);</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>            }</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>        }</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>        </div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>        <span class="keywordtype">int</span> recipeCount = 0;</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>        </div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>        <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a77951b2f295e03439335f622e554d26c">m_craftingMode</a> == <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ab8193febe884400782cfa280e90d76d3">CM_MODE_INVENTORY</a>)</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>        {</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>            recipeCount = <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#adbd5f83d3c27e17223ebf1800a98698d">m_recipesManager</a>.GetValidRecipes(<a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ad6ebd6b1f6ef0a91b33aeb8989065480">m_item1</a>, <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a2fbd85d524f1eb183d21c2c129041f86">m_item2</a>, <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a170fde65a6c0be64a4e3388d1ba1f271">m_recipes</a>, <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac0b173f5f92412d43d2db3a9ddb8f431">m_player</a>);</div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>            <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac3c9a0c305d2d9485d14bbc9aaa730b8">m_recipeCount</a> = recipeCount;</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>            <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a2e33a35b16fddc62a3c41f93c4d580e1">m_recipeID</a> = <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a170fde65a6c0be64a4e3388d1ba1f271">m_recipes</a>.Get(<a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a73cb57468e476308578833901ef8fbcf">m_contextualRecipeID</a>);</div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>        }</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>        </div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>        recipeCount = <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#adbd5f83d3c27e17223ebf1800a98698d">m_recipesManager</a>.GetValidRecipes(item1, item2, <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a170fde65a6c0be64a4e3388d1ba1f271">m_recipes</a>, <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac0b173f5f92412d43d2db3a9ddb8f431">m_player</a>);</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span> </div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>        <span class="keywordflow">if</span> (recipeCount == 0)</div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>        {</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>            <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac3c9a0c305d2d9485d14bbc9aaa730b8">m_recipeCount</a> = 0;</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>            <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a77951b2f295e03439335f622e554d26c">m_craftingMode</a> = <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a88610f641a67c5d0324f194c5a8510a4">CM_MODE_NONE</a>;</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>            <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#afe03b4ca722762ad9c475d6c04d968d5">m_actionVariantManager</a>.<a class="code hl_function" href="../../dd/dfb/class_action_variant_manager.html#a97283f11538fbcc2b3b53b2fd705a969">Clear</a>();</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>        }</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>        {</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>            <span class="keywordflow">if</span> ( <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a77951b2f295e03439335f622e554d26c">m_craftingMode</a> == <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a88610f641a67c5d0324f194c5a8510a4">CM_MODE_NONE</a> || <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac3c9a0c305d2d9485d14bbc9aaa730b8">m_recipeCount</a> != recipeCount  || <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ad6ebd6b1f6ef0a91b33aeb8989065480">m_item1</a> != item1  || <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a2fbd85d524f1eb183d21c2c129041f86">m_item2</a> != item2 )</div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>            {</div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>                <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a77951b2f295e03439335f622e554d26c">m_craftingMode</a> = <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a49e45ddb0c3044c28f0571577422ff9a">CM_MODE_WORLD</a>;</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>                <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac3c9a0c305d2d9485d14bbc9aaa730b8">m_recipeCount</a> = recipeCount;</div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>                <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a73cb57468e476308578833901ef8fbcf">m_contextualRecipeID</a> = 0;</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>                <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ad6ebd6b1f6ef0a91b33aeb8989065480">m_item1</a> = item1;</div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>                <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a2fbd85d524f1eb183d21c2c129041f86">m_item2</a> = item2;</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>                </div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>                <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#afe03b4ca722762ad9c475d6c04d968d5">m_actionVariantManager</a>.<a class="code hl_function" href="../../dd/dfb/class_action_variant_manager.html#ab32701c281e4b7ee9f3bf9aa0ac47c78">SetActionVariantCount</a>(<a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac3c9a0c305d2d9485d14bbc9aaa730b8">m_recipeCount</a>);</div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>            }</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>            <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a2e33a35b16fddc62a3c41f93c4d580e1">m_recipeID</a> = <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a170fde65a6c0be64a4e3388d1ba1f271">m_recipes</a>.Get(<a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a73cb57468e476308578833901ef8fbcf">m_contextualRecipeID</a>);</div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>        }</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>        </div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>    }</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>    </div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#a34bceac8fd8b9e2c604fc56d5fa9dc4d">  128</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d4/db5/class_crafting_manager.html#a34bceac8fd8b9e2c604fc56d5fa9dc4d">SetInventoryCraft</a>(<span class="keywordtype">int</span> recipeID, <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> item1, <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> item2)</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>    {</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>        <span class="keywordtype">int</span> recipeCount = <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#adbd5f83d3c27e17223ebf1800a98698d">m_recipesManager</a>.GetValidRecipes(item1,item2,<a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a170fde65a6c0be64a4e3388d1ba1f271">m_recipes</a>, <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac0b173f5f92412d43d2db3a9ddb8f431">m_player</a>);</div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>        </div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>        <span class="keywordflow">for</span> ( <span class="keywordtype">int</span> i = 0; i &lt; recipeCount; i++ )</div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>        {</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>            <span class="keywordflow">if</span> (recipeID == -1 || <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a170fde65a6c0be64a4e3388d1ba1f271">m_recipes</a>.Get(i) == recipeID)</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>            {</div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>                <span class="keywordflow">if</span> ( <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#adbd5f83d3c27e17223ebf1800a98698d">m_recipesManager</a>.GetIsInstaRecipe(<a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a170fde65a6c0be64a4e3388d1ba1f271">m_recipes</a>.Get(i)) || <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#adbd5f83d3c27e17223ebf1800a98698d">m_recipesManager</a>.IsEnableDebugCrafting() )</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>                {</div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>                    <a class="code hl_class" href="../../d9/dc3/group___tools.html#de/d90/class_param">Param</a> craftParam = <span class="keyword">new</span> Param3&lt;int, ItemBase, ItemBase&gt;(<a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a170fde65a6c0be64a4e3388d1ba1f271">m_recipes</a>.Get(i), item1, item2);</div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>                    <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac0b173f5f92412d43d2db3a9ddb8f431">m_player</a>.RPCSingleParam(<a class="code hl_enumeration" href="../../d0/d66/_e_r_p_cs_8c.html#a6ce2d98a3b8fbdba5b450abf2d6eab37">ERPCs</a>.RPC_CRAFTING_INVENTORY_INSTANT, craftParam, <span class="keyword">true</span>, <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac0b173f5f92412d43d2db3a9ddb8f431">m_player</a>.GetIdentity());</div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>                    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>                }</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>                <span class="keywordflow">else</span></div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>                {</div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>                    <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a77951b2f295e03439335f622e554d26c">m_craftingMode</a> = <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ab8193febe884400782cfa280e90d76d3">CM_MODE_INVENTORY</a>;</div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>                    <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac3c9a0c305d2d9485d14bbc9aaa730b8">m_recipeCount</a> = recipeCount;</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span>                    <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a73cb57468e476308578833901ef8fbcf">m_contextualRecipeID</a> = i;</div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>                    <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ad6ebd6b1f6ef0a91b33aeb8989065480">m_item1</a> = item1;</div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>                    <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a2fbd85d524f1eb183d21c2c129041f86">m_item2</a> = item2;</div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>                    <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a2e33a35b16fddc62a3c41f93c4d580e1">m_recipeID</a> = <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a170fde65a6c0be64a4e3388d1ba1f271">m_recipes</a>.Get(i);</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span> </div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>                    <a class="code hl_class" href="../../d7/da1/class_action_manager_client.html">ActionManagerClient</a> am = <a class="code hl_class" href="../../d7/da1/class_action_manager_client.html">ActionManagerClient</a>.Cast(<a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac0b173f5f92412d43d2db3a9ddb8f431">m_player</a>.GetActionManager());</div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>                    </div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span>                    <span class="keywordflow">if</span> ( <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac0b173f5f92412d43d2db3a9ddb8f431">m_player</a>.GetItemInHands() == item1) am.<a class="code hl_function" href="../../d7/da1/class_action_manager_client.html#a3551bb9a6955160acaf736f3bd1b7fe1">SetInventoryAction</a>( am.<a class="code hl_function" href="../../d9/dd1/class_action_manager_base.html#a8a0b5eca21a6cdcb981c5e6cfa949254">GetAction</a>(<a class="code hl_class" href="../../d6/def/class_action_world_craft.html">ActionWorldCraft</a>), item2, item1);</div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>                    <span class="keywordflow">else</span> am.<a class="code hl_function" href="../../d7/da1/class_action_manager_client.html#a3551bb9a6955160acaf736f3bd1b7fe1">SetInventoryAction</a>( am.<a class="code hl_function" href="../../d9/dd1/class_action_manager_base.html#a8a0b5eca21a6cdcb981c5e6cfa949254">GetAction</a>(<a class="code hl_class" href="../../d6/def/class_action_world_craft.html">ActionWorldCraft</a>), item1, item2);                  </div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span> </div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span>                    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>                }       </div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>            }           </div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>            </div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>        }   </div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>    }</div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>    </div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#a9120b655cdb683c5cc63c0bd9308f5ea">  164</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/db5/class_crafting_manager.html#a9120b655cdb683c5cc63c0bd9308f5ea">ResetInventoryCraft</a>()</div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>    {</div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>        <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#ac3c9a0c305d2d9485d14bbc9aaa730b8">m_recipeCount</a> = 0;</div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>        <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a77951b2f295e03439335f622e554d26c">m_craftingMode</a> = <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a88610f641a67c5d0324f194c5a8510a4">CM_MODE_NONE</a>;</div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>    }</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>    </div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#abf87ebf09b0ee6e54ac69bbbf79cd941">  170</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d4/db5/class_crafting_manager.html#abf87ebf09b0ee6e54ac69bbbf79cd941">IsEnableDebugCrafting</a>()</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>    {</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>    }</div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>    </div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno"><a class="line" href="../../d4/db5/class_crafting_manager.html#ae34a664a52b4ed063de1cc31450de669">  175</a></span>    <span class="keywordtype">int</span> <a class="code hl_function" href="../../d4/db5/class_crafting_manager.html#ae34a664a52b4ed063de1cc31450de669">GetRecipeID</a>( <span class="keywordtype">int</span> action_index )</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>    {</div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d4/db5/class_crafting_manager.html#a170fde65a6c0be64a4e3388d1ba1f271">m_recipes</a>[action_index];</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>    }</div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>}</div>
<div class="ttc" id="a_e_r_p_cs_8c_html_a6ce2d98a3b8fbdba5b450abf2d6eab37"><div class="ttname"><a href="../../d0/d66/_e_r_p_cs_8c.html#a6ce2d98a3b8fbdba5b450abf2d6eab37">ERPCs</a></div><div class="ttdeci">ERPCs</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d66/_e_r_p_cs_8c_source.html#l00001">ERPCs.c:2</a></div></div>
<div class="ttc" id="aclass_action_manager_base_html_a8a0b5eca21a6cdcb981c5e6cfa949254"><div class="ttname"><a href="../../d9/dd1/class_action_manager_base.html#a8a0b5eca21a6cdcb981c5e6cfa949254">ActionManagerBase::GetAction</a></div><div class="ttdeci">static ActionBase GetAction(typename actionName)</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/db9/_action_manager_base_8c_source.html#l00173">ActionManagerBase.c:173</a></div></div>
<div class="ttc" id="aclass_action_manager_client_html"><div class="ttname"><a href="../../d7/da1/class_action_manager_client.html">ActionManagerClient</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dae/_action_manager_client_8c_source.html#l00004">ActionManagerClient.c:5</a></div></div>
<div class="ttc" id="aclass_action_manager_client_html_a3551bb9a6955160acaf736f3bd1b7fe1"><div class="ttname"><a href="../../d7/da1/class_action_manager_client.html#a3551bb9a6955160acaf736f3bd1b7fe1">ActionManagerClient::SetInventoryAction</a></div><div class="ttdeci">void SetInventoryAction(ActionBase action_name, ItemBase target_item, ItemBase main_item)</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dae/_action_manager_client_8c_source.html#l00766">ActionManagerClient.c:766</a></div></div>
<div class="ttc" id="aclass_action_manager_client_html_ae1daf331f86facb73f8b9efbacc9031c"><div class="ttname"><a href="../../d7/da1/class_action_manager_client.html#ae1daf331f86facb73f8b9efbacc9031c">ActionManagerClient::GetVariantManager</a></div><div class="ttdeci">static ActionVariantManager GetVariantManager(typename actionName)</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dae/_action_manager_client_8c_source.html#l00311">ActionManagerClient.c:311</a></div></div>
<div class="ttc" id="aclass_action_variant_manager_html"><div class="ttname"><a href="../../dd/dfb/class_action_variant_manager.html">ActionVariantManager</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d6/db5/_action_variants_manager_8c_source.html#l00001">ActionVariantsManager.c:2</a></div></div>
<div class="ttc" id="aclass_action_variant_manager_html_a18286657e9f50784b4839e7f886cba09"><div class="ttname"><a href="../../dd/dfb/class_action_variant_manager.html#a18286657e9f50784b4839e7f886cba09">ActionVariantManager::GetOnUpdateInvoker</a></div><div class="ttdeci">ScriptInvoker GetOnUpdateInvoker()</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/db5/_action_variants_manager_8c_source.html#l00014">ActionVariantsManager.c:14</a></div></div>
<div class="ttc" id="aclass_action_variant_manager_html_a97283f11538fbcc2b3b53b2fd705a969"><div class="ttname"><a href="../../dd/dfb/class_action_variant_manager.html#a97283f11538fbcc2b3b53b2fd705a969">ActionVariantManager::Clear</a></div><div class="ttdeci">void Clear()</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/db5/_action_variants_manager_8c_source.html#l00019">ActionVariantsManager.c:19</a></div></div>
<div class="ttc" id="aclass_action_variant_manager_html_ab32701c281e4b7ee9f3bf9aa0ac47c78"><div class="ttname"><a href="../../dd/dfb/class_action_variant_manager.html#ab32701c281e4b7ee9f3bf9aa0ac47c78">ActionVariantManager::SetActionVariantCount</a></div><div class="ttdeci">void SetActionVariantCount(int count)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/db5/_action_variants_manager_8c_source.html#l00024">ActionVariantsManager.c:24</a></div></div>
<div class="ttc" id="aclass_action_world_craft_html"><div class="ttname"><a href="../../d6/def/class_action_world_craft.html">ActionWorldCraft</a></div><div class="ttdef"><b>Definition:</b> <a href="../../df/dde/_action_world_craft_8c_source.html#l00032">ActionWorldCraft.c:33</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html">CraftingManager</a></div><div class="ttdoc">Client only - manage set up crafting on client.</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00002">CraftingManager.c:3</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_a170fde65a6c0be64a4e3388d1ba1f271"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#a170fde65a6c0be64a4e3388d1ba1f271">CraftingManager::m_recipes</a></div><div class="ttdeci">ref array&lt; int &gt; m_recipes</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00018">CraftingManager.c:18</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_a2b252f87edfa03639003562f38f0a30f"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#a2b252f87edfa03639003562f38f0a30f">CraftingManager::CraftingManager</a></div><div class="ttdeci">void CraftingManager(PlayerBase player, PluginRecipesManager recipesManager)</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00020">CraftingManager.c:20</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_a2e33a35b16fddc62a3c41f93c4d580e1"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#a2e33a35b16fddc62a3c41f93c4d580e1">CraftingManager::m_recipeID</a></div><div class="ttdeci">int m_recipeID</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00011">CraftingManager.c:11</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_a2fbd85d524f1eb183d21c2c129041f86"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#a2fbd85d524f1eb183d21c2c129041f86">CraftingManager::m_item2</a></div><div class="ttdeci">ItemBase m_item2</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00016">CraftingManager.c:16</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_a34bceac8fd8b9e2c604fc56d5fa9dc4d"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#a34bceac8fd8b9e2c604fc56d5fa9dc4d">CraftingManager::SetInventoryCraft</a></div><div class="ttdeci">bool SetInventoryCraft(int recipeID, ItemBase item1, ItemBase item2)</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00128">CraftingManager.c:128</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_a34f6e34fa2e440b3378332d9dd69e003"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#a34f6e34fa2e440b3378332d9dd69e003">CraftingManager::GetRecipesCount</a></div><div class="ttdeci">int GetRecipesCount()</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00051">CraftingManager.c:51</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_a3bbc9b43adb537feb84300a3ce6dc4aa"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#a3bbc9b43adb537feb84300a3ce6dc4aa">CraftingManager::IsInventoryCraft</a></div><div class="ttdeci">bool IsInventoryCraft()</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00041">CraftingManager.c:41</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_a49e45ddb0c3044c28f0571577422ff9a"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#a49e45ddb0c3044c28f0571577422ff9a">CraftingManager::CM_MODE_WORLD</a></div><div class="ttdeci">const int CM_MODE_WORLD</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00005">CraftingManager.c:5</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_a5cd5f0e4798594b92213aa9d53ea2a45"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#a5cd5f0e4798594b92213aa9d53ea2a45">CraftingManager::OnUpdate</a></div><div class="ttdeci">void OnUpdate(Object item, Object target, int component_index)</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00061">CraftingManager.c:61</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_a6a4c63fac63c466fbc5c3f7a861b4611"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#a6a4c63fac63c466fbc5c3f7a861b4611">CraftingManager::IsWorldCraft</a></div><div class="ttdeci">bool IsWorldCraft()</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00046">CraftingManager.c:46</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_a6da973233f240fdaac28e2cad6f97631"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#a6da973233f240fdaac28e2cad6f97631">CraftingManager::SetNextRecipe</a></div><div class="ttdeci">void SetNextRecipe()</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00056">CraftingManager.c:56</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_a73cb57468e476308578833901ef8fbcf"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#a73cb57468e476308578833901ef8fbcf">CraftingManager::m_contextualRecipeID</a></div><div class="ttdeci">int m_contextualRecipeID</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00012">CraftingManager.c:12</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_a77951b2f295e03439335f622e554d26c"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#a77951b2f295e03439335f622e554d26c">CraftingManager::m_craftingMode</a></div><div class="ttdeci">int m_craftingMode</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00014">CraftingManager.c:14</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_a88610f641a67c5d0324f194c5a8510a4"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#a88610f641a67c5d0324f194c5a8510a4">CraftingManager::CM_MODE_NONE</a></div><div class="ttdeci">const int CM_MODE_NONE</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00004">CraftingManager.c:4</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_a911ea59400a6afa0eb7abcfe7d04d8d0"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#a911ea59400a6afa0eb7abcfe7d04d8d0">CraftingManager::GetRecipeID</a></div><div class="ttdeci">int GetRecipeID()</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00036">CraftingManager.c:36</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_a9120b655cdb683c5cc63c0bd9308f5ea"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#a9120b655cdb683c5cc63c0bd9308f5ea">CraftingManager::ResetInventoryCraft</a></div><div class="ttdeci">void ResetInventoryCraft()</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00164">CraftingManager.c:164</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_ab8193febe884400782cfa280e90d76d3"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#ab8193febe884400782cfa280e90d76d3">CraftingManager::CM_MODE_INVENTORY</a></div><div class="ttdeci">const int CM_MODE_INVENTORY</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00006">CraftingManager.c:6</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_abf87ebf09b0ee6e54ac69bbbf79cd941"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#abf87ebf09b0ee6e54ac69bbbf79cd941">CraftingManager::IsEnableDebugCrafting</a></div><div class="ttdeci">bool IsEnableDebugCrafting()</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00170">CraftingManager.c:170</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_ac0b173f5f92412d43d2db3a9ddb8f431"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#ac0b173f5f92412d43d2db3a9ddb8f431">CraftingManager::m_player</a></div><div class="ttdeci">PlayerBase m_player</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00008">CraftingManager.c:8</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_ac3c9a0c305d2d9485d14bbc9aaa730b8"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#ac3c9a0c305d2d9485d14bbc9aaa730b8">CraftingManager::m_recipeCount</a></div><div class="ttdeci">int m_recipeCount</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00013">CraftingManager.c:13</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_ad6ebd6b1f6ef0a91b33aeb8989065480"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#ad6ebd6b1f6ef0a91b33aeb8989065480">CraftingManager::m_item1</a></div><div class="ttdeci">ItemBase m_item1</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00015">CraftingManager.c:15</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_adbd5f83d3c27e17223ebf1800a98698d"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#adbd5f83d3c27e17223ebf1800a98698d">CraftingManager::m_recipesManager</a></div><div class="ttdeci">PluginRecipesManager m_recipesManager</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00009">CraftingManager.c:9</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_ae34a664a52b4ed063de1cc31450de669"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#ae34a664a52b4ed063de1cc31450de669">CraftingManager::GetRecipeID</a></div><div class="ttdeci">int GetRecipeID(int action_index)</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00175">CraftingManager.c:175</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_afa1ece4b767b0b206cf0b52dca1049e6"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#afa1ece4b767b0b206cf0b52dca1049e6">CraftingManager::SetRecipeID</a></div><div class="ttdeci">void SetRecipeID(int recipeID)</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00031">CraftingManager.c:31</a></div></div>
<div class="ttc" id="aclass_crafting_manager_html_afe03b4ca722762ad9c475d6c04d968d5"><div class="ttname"><a href="../../d4/db5/class_crafting_manager.html#afe03b4ca722762ad9c475d6c04d968d5">CraftingManager::m_actionVariantManager</a></div><div class="ttdeci">ActionVariantManager m_actionVariantManager</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d38/_crafting_manager_8c_source.html#l00010">CraftingManager.c:10</a></div></div>
<div class="ttc" id="aclass_inventory_location_html"><div class="ttname"><a href="../../d6/dc5/class_inventory_location.html">InventoryLocation</a></div><div class="ttdoc">InventoryLocation.</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d52/_inventory_location_8c_source.html#l00027">InventoryLocation.c:28</a></div></div>
<div class="ttc" id="aclass_inventory_location_html_ae6e0792c2508f75cb3c15d5f7e7a2b8e"><div class="ttname"><a href="../../d6/dc5/class_inventory_location.html#ae6e0792c2508f75cb3c15d5f7e7a2b8e">InventoryLocation::DumpToString</a></div><div class="ttdeci">string DumpToString()</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d52/_inventory_location_8c_source.html#l00225">InventoryLocation.c:225</a></div></div>
<div class="ttc" id="aclass_item_base_html"><div class="ttname"><a href="../../de/d7a/class_item_base.html">ItemBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d82/4___world_2_entities_2_core_2_inherited_2_inventory_item_8c_source.html#l00691">InventoryItem.c:692</a></div></div>
<div class="ttc" id="aclass_object_html"><div class="ttname"><a href="../../d8/d83/class_object.html">Object</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d7/d68/_object_typed_8c_source.html#l00001">ObjectTyped.c:2</a></div></div>
<div class="ttc" id="aclass_player_base_html"><div class="ttname"><a href="../../d5/da8/class_player_base.html">PlayerBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../dd/d23/_player_base_client_8c_source.html#l00001">PlayerBaseClient.c:2</a></div></div>
<div class="ttc" id="aclass_script_invoker_html_a57356e0ea629b280f24b5fcbe488a528"><div class="ttname"><a href="../../d4/d2d/class_script_invoker.html#a57356e0ea629b280f24b5fcbe488a528">ScriptInvoker::Clear</a></div><div class="ttdeci">proto native void Clear()</div><div class="ttdoc">remove all calls from list</div></div>
<div class="ttc" id="aclass_script_invoker_html_abeb2392b2e3dc0a34d0c5cafc96a288e"><div class="ttname"><a href="../../d4/d2d/class_script_invoker.html#abeb2392b2e3dc0a34d0c5cafc96a288e">ScriptInvoker::Insert</a></div><div class="ttdeci">proto void Insert(func fn)</div><div class="ttdoc">insert method to list</div></div>
<div class="ttc" id="aclassarray_html"><div class="ttname"><a href="../../d2/d41/classarray.html">array</a></div><div class="ttdoc">Result for an object found in CGame.IsBoxCollidingGeometryProxy.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcd/_is_box_colliding_geometry_proxy_classes_8c_source.html#l00027">IsBoxCollidingGeometryProxyClasses.c:28</a></div></div>
<div class="ttc" id="agroup___debug_html_ga786b160dafbe15abb829786ba345cb15"><div class="ttname"><a href="../../d0/d62/group___debug.html#ga786b160dafbe15abb829786ba345cb15">Error</a></div><div class="ttdeci">void Error(string err)</div><div class="ttdoc">Messagebox with error message.</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d19/_en_debug_8c_source.html#l00090">EnDebug.c:90</a></div></div>
<div class="ttc" id="agroup___tools_html_de/d90/class_param"><div class="ttname"><a href="../../d9/dc3/group___tools.html#de/d90/class_param">Param</a></div><div class="ttdoc">Base Param Class with no parameters. Used as general purpose parameter overloaded with Param1 to Para...</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/da5/param_8c_source.html#l00011">param.c:12</a></div></div>
<div class="ttc" id="agroup___tools_html_gab414e48870421e21bf5553f4033493b0"><div class="ttname"><a href="../../d9/dc3/group___tools.html#gab414e48870421e21bf5553f4033493b0">OnUpdate</a></div><div class="ttdeci">proto native void OnUpdate()</div><div class="ttdef"><b>Definition:</b> <a href="../../df/dc2/3___game_2tools_2tools_8c_source.html#l00338">tools.c:338</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_dc42280174b209627d8212c9e40d7e50.html">scripts</a></li><li class="navelem"><a class="el" href="../../dir_2e5c1ab951ac691cd4fc8c5e713c6c8a.html">4_World</a></li><li class="navelem"><a class="el" href="../../dir_f61fac3e195407e8bd798ede36822932.html">Classes</a></li><li class="navelem"><a class="el" href="../../d5/d38/_crafting_manager_8c.html">CraftingManager.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
